<?php
// get localized
load_plugin_textdomain('filez');

// fill the options array with the stored data if it's there
$filez_options = array();
if (get_option('filez_options')) {
	$filez_options = get_option('filez_options');
}

// use tags by default
if ($filez_options['use_tags'] != '0' && $filez_options['use_tags'] != '1') {
	$filez_options['use_tags'] = '1';
}

// default capability is edit_posts
if (empty($filez_options['capability'])) {
	$filez_options['capability'] = 'edit_posts';
}

// allowed file extensions, separated by spaces (none means anything goes)
if (empty($filez_options['extensions'])) {
	$filez_options['extensions'] = '';
}

// guess the address if it's not set in Options
if (empty($filez_options['address'])) {
	$filez_options['address'] = get_settings('siteurl') . '/wp-content/files/';
}

// guess the path if it's not set in Options
if (empty($filez_options['path'])) {
	$filez_options['path'] = ABSPATH . 'wp-content/files/';
}

// Returns an array of files at the supplied path
function filez_folder_contents($path) {
	$list_array = array();
	if ($handle = @opendir($path)) {
		while (false !== ($file = readdir($handle))) {
			if ($file != "." && $file != "..") {
				$list_array[] = $file;
			}
		}
	}
	if (count($list_array) > 1) {
		sort($list_array);
	}
	if (count($list_array) > 0) {
		return $list_array;
	} else {
		return FALSE;
	}
}

?>
