<?php
/* Filez Uploader and Browser */
require_once( dirname(dirname(dirname(dirname(__FILE__)))) . '/wp-config.php');
require_once( ABSPATH . 'wp-content/plugins/filez/include.php');
if ($user_ID == '')
	die (__('Try logging in','filez'));
if (!current_user_can($filez_options['capability']))
	die (__('Ask the administrator to promote you.','filez'));
// print the header (probably a better way to do this)
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>WordPress &rsaquo; Filez</title>
<link rel="stylesheet" href="' . get_settings('siteurl') . '/wp-admin/wp-admin.css" type="text/css" />
<link rel="shortcut icon" href="' . get_settings('siteurl') . '/wp-images/wp-favicon.png" />
<meta http-equiv="Content-Type" content="text/html; charset=' . get_settings('blog_charset') . '" />
<script type="text/javascript">
//<![CDATA[
window.focus();
function insertcode(blah) {
	var usetags = "' . $filez_options['use_tags'] . '";
	if (usetags == "1") {
		var linkcode = "[filez:" + blah + "]";
	} else {
		var linkcode = "<a href=\'' . $filez_options['address'] . '" + blah + "\'>" + blah + "</a>";
	}
   var winder = window.opener ? window.opener : window.dialogArguments;
   if ( !winder ) {
      winder = top;
   }
   tinyMCE = winder.tinyMCE;
   if ( typeof tinyMCE != "undefined" && tinyMCE.getInstanceById("content") ) {
      tinyMCE.selectedInstance.getWin().focus();
      tinyMCE.execCommand("mceInsertContent", false, linkcode);
   } else {
      edCanvas = window.opener.document.post.content;
      winder.edInsertContent(edCanvas, linkcode);
   }
   return;
}
//]]>
</script>
</head>
<body>
	<ul id="adminmenu">
		<li><a '; if ($_GET['action'] == 'upload' || $_POST['submit']) { echo 'class="current" ';} echo 'href="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php?action=upload">' . __('Upload','filez') . '</a></li>
		<li><a ';  if ($_GET['action'] == 'browse') { echo 'class="current" ';} echo 'href="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php?action=browse">' . __('Browse','filez') . '</a></li>
		<li><a href="#" onclick="window.close()">' . __('Close window','filez') . '</a></li>
	</ul>
<div class="wrap">
';

// check the folder for writability
if (!is_writable($filez_options['path'])) {
	echo '<h3>' . __('Folder Not Writable','filez') . '</h3>
	<p>';
	printf(__("It doesn't look like you can use Filez at this time because the directory you have specified (<code>%s</code>) isn't writable. Check the permissions on the directory and for typos in your configuration.","filez"), $filez_options['path']);
	echo '</p>
	</div>
</body>
</html>';
	die();
}

// display the file browser
if ($_GET['action'] == 'browse') {
	echo '<h3>' . __('Browsing Uploaded Files','filez') . '</h3>
	';
	$files_per_page = 10;
	$files_list = array();
	$files_list = filez_folder_contents($filez_options['path']);
	$files_count = count($files_list);
	if (!empty($files_list)) {
		echo '<p>' . __('in','filez') . ' <code>' . $filez_options['path'] . '</code></p>
		<p>' . __('Click to insert a link to a file into your post. This window will remain open so you can insert multiple links.','filez') . '</p>
		';
		$pages = ceil($files_count/$files_per_page);
		if ($pages > 1) {
			if (isset($_GET['page'])) {
				$current_page = $_GET['page'];
			} else {
				$current_page = 1;
			}
			$page_code = '<p>';
			for ($i = 1; $i <= $pages; $i++) {
				if ($i != $current_page) {
					$page_code .= '<a href="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php?action=browse&amp;page=' . $i . '">';
				}
				$page_code .= __('Page','filez') . ' ' . $i;
				if ($i != $current_page) {
					$page_code .= '</a>';
				}
				if ($i < $pages) {
					$page_code .= ' | ';
				}
			}
			$list_start = ($current_page - 1) * $files_per_page;
			$current_file_list = array_slice($files_list, $list_start, $files_per_page);
			$page_code .= '</p>';
			echo $page_code;
		} else { // there's only one page so let's show the whole list
			$current_file_list = $files_list;
		}
		foreach ((array)$current_file_list as $file) {
			echo '<form name="filez" method="post">';
			if (strlen($file) > 25) {
				$shortfile = substr($file,0,22) . '...';
			} else {
				$shortfile = $file;
			}
			$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
			$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
			echo '<p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $file . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p>
			</form>';
		}
		echo $page_code;
	} else {
		echo '<p>' . __('No files found at:','filez') . ' <code>' . $filez_options['path'] . '</code></p>';
	}
		echo '
	</div>
</body>
</html>';
die();
}

// display the upload form
if ($_GET['action'] == 'upload') {
	echo '<h3>' . __('Upload a File','filez') . "</h3>\n";
	if (!empty($filez_options['extensions'])) {
		echo "<p>" . __('You may upload the following types of files: ','filez') . '<strong>' . $filez_options['extensions'] . "</strong></p>\n";
	}
	echo '<form action="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data">
		<input type="hidden" name="upload" id="upload" value="yes" />
		<p><label for="file1">' . __('File:','filez') . '</label><br />
		<input type="file" name="file_name" id="file_name" size="30" class="uploadform" /></p>
		<p class="submit"><input type="submit" name="submit" value="' . __('Upload File','filez') . ' &raquo;" /></p>
		</form>
	</div>
</body>
</html>';
die();
}

// process the upload
if ($_POST['submit']) {
	if ($_POST['cancel']) {
		echo '<h3>' . __('Cancelled Upload','filez') . '</h3>
		';
		$file_location = $filez_options['path'] . $_POST['cancel'];
		if (file_exists($file_location)) {
			if (@unlink($file_location)) {
				printf(__('<div class="updated">Deleted <strong>%s</strong> successfully.</div>','filez'),$_POST['cancel']);
			} else {
				printf(__('<div class="updated">Failed to delete <strong>%s</strong>.</div>','filez'),$_POST['cancel']);
			}
		}
		echo '
	</body>
</html>';
		die();
	} elseif (isset($_POST['rename'])) {
		echo '<h3>' . __('Renaming File','filez') . '</h3>
		';
		$temp_location = $filez_options['path'] . $_POST['rename'];
		$new_location = $filez_options['path'] . $_POST['new_name'];
		if ($_POST['rename'] === $_POST['new_name']) {
			echo '<div class="updated">' . __('The file already has that name.','filez') . '</div>
			';
			if (strlen($_POST['rename']) > 25) {
				$shortfile = substr($_POST['rename'],0,22) . '...';
			} else {
				$shortfile = $_POST['rename'];
			}
			$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
			$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
			echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $_POST['new_name'] . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p></form>
				<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data"><p class="submit"><input type="hidden" name="cancel" value="' . $_POST['rename'] . '" /><input type="submit" name="submit" value="' . __('Delete','filez') . ' (' . $_POST['rename'] . ') &raquo;" /></p></form>
		</div>
	</body>
</html>';
			die();
		} elseif (file_exists($new_location)) {
			echo '<div class="updated">' . __('There is already a file with that name, please try another or cancel the upload.','filez') . '</div>
			<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data">
			<p>' . __('New name:','filez') . '<input type="text" name="new_name" value="' . $_POST['new_name'] . '" /><input type="hidden" name="rename" value="' . $_POST['rename'] . '" /></p>
			<p class="submit"><input type="submit" name="submit" value="' . __('Rename','filez') . ' &raquo;" /></p>
			</form>';
			if (strlen($_POST['rename']) > 25) {
				$shortfile = substr($_POST['rename'],0,22) . '...';
			} else {
				$shortfile = $_POST['rename'];
			}
			$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
			$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
			echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $_POST['new_name'] . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p></form>
			<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data"><p class="submit"><input type="hidden" name="cancel" value="' . $_POST['rename'] . '" /><input type="submit" name="submit" value="' . __('Delete','filez') . ' (' . $_POST['rename'] . ') &raquo;" /></p></form>
		</div>
	</body>
</html>';
			die();
		} else {
			echo '<div class="updated">';
			if (!@rename($temp_location,$new_location)) {
				echo __('Failed to rename the file for some reason.','filez') . '</div>
		</div>
	</body>
</html>';
				die();
			} else {
				printf(__('Renamed uploaded file %s.','filez'),$_POST['new_name']);
				echo '</div>';
				if (strlen($_POST['new_name']) > 25) {
					$shortfile = substr($_POST['new_name'],0,22) . '...';
				} else {
					$shortfile = $_POST['new_name'];
				}
				$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
				$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
				echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $_POST['new_name'] . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p></form>
		</div>
	</body>
</html>';
				die();
			}
		}
	} elseif (isset($_POST['replace'])) {
		echo '<h3>' . __('Replacing File','filez') . '</h3>';
		$file_location = $filez_options['path'] . $_POST['file_name'];
		$temp_location = $filez_options['path'] . $_POST['temp_name'];
		$file_name = $_POST['file_name'];
		echo '<div class="updated">';
		if (file_exists($file_location)) {
			if (@unlink($file_location)) {
				if (@rename($temp_location,$file_location)) {
					printf(__('Replaced %s with uploaded file.','filez'),$file_name);
				} else {
					printf(__('Deleted %s but failed to move uploaded file. ','filez'),$file_name);
				}
			} else {
				printf(__('Failed to delete %s, left uploaded file in place.','filez'),$file_name);
			}
		} else {
			echo __('Could not find the file for some reason.','filez');
		}
		echo '</div>';
		if (strlen($file_name) > 25) {
			$shortfile = substr($file_name,0,22) . '...';
		} else {
			$shortfile = $file_name;
		}
		$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
		$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
		echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $file_name . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p></form>
	</div>
</body>
</html>';
		die();
	} elseif ($_POST['upload']) { // an upload was attempted
		if (is_array($_FILES)) { // hooray, there's an array of data to look at
			$error = $_FILES['file_name']['error'];
			if ($error == UPLOAD_ERR_OK) { // PHP thinks the upload worked
				$file_pathinfo = pathinfo($_FILES['file_name']['name']);
				$file_name = preg_replace('/[^a-z0-9_.]/i','_',$file_pathinfo['basename']); // clean up the filename
				$temp_location = $_FILES['file_name']['tmp_name']; // this is where the file is now
				if (isset($file_pathinfo['extension'])) {
					$extension = trim(strtolower(pathinfo($file_name,PATHINFO_EXTENSION))); // the cleaned filename's cleaned extension
				}
				$file_location = $filez_options['path'] . $file_name; // where we'd like to put the file
				if (!empty($filez_options['extensions'])) { // we've got rules for extensions so let's make an array of 'em
					$extensions = array();
					$extensions = explode(' ', trim(strtolower($filez_options['extensions'])));
					if (isset($extension)) {
						if (!in_array($extension, $extensions)) {
							@unlink($temp_location);
							echo '<h3>' . __('Upload Failed','filez') . "</h3>\n<p>";
							printf(__('Your file, <strong>%1$s</strong>, did not have one of the allowed extensions: <strong>%2$s</strong>.','filez'),$_FILES['file_name']['name'],$filez_options['extensions']);
							echo "</p>\n</div>\n</body>\n</html>";
							die();
						}
					}
				}
				if (is_file($file_location)) {
					$old_name = $file_name;
					$i = 1;
					while (is_file($file_location)) { // there's already a file there! let's find a new name to use
						if (isset($extension)) { // if there's an extension let's add the number before it (messes up tar.gz...)
							$base = substr($file_name, 0, strrpos($file_name, '.'));
							$file_name = $base . $i . '.' . $extension;
						} else {
							$file_name = $file_name . $i;
						}
						$file_location = $filez_options['path'] . $file_name; // new location to check
						$i++; // increment if we found a file there
					}
					if (!@move_uploaded_file($temp_location,$file_location)) { // try to move the file to its destination
						@unlink($temp_location);
						echo '<h3>' . __('Upload Failed','filez') . "</h3>\n<p>";
						printf(__('Your file could not be moved to <strong>%s</strong>. Make sure the folder is writable.','filez'),$filez_options['path']);
						echo "</p>\n</div>\n</body>\n</html>";
						die();
					}
					echo "\n<h3>" . __('Duplicate File','filez') . "</h3>\n<p>";
					printf(__("A file called <strong>%1\$s</strong> has already been uploaded. Your file has been stored as <strong>%2\$s</strong>. You can leave it with this name, try another name, replace the existing file with your new file, or delete the new file. Only replace if you know you do not want the other file anymore.","filez"), $old_name, $file_name);
					echo "</p>\n";
					if (strlen($file_name) > 25) {
						$shortfile = substr($file_name,0,22) . '...';
					} else {
						$shortfile = $file_name;
					}
					$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
					$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
					echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $file_name . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" /></p></form>' . "\n" . '<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data"><p class="alignright"><input type="text" name="new_name" value="' . $file_name . '" /><input type="hidden" name="rename" value="' . $file_name . '" /><span class="submit"><input type="submit" name="submit" value="' . __('Rename','filez') . ' &raquo;" /></span></p></form>' . "\n" . '<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data"><input type="hidden" name="replace" value="true" /><input type="hidden" name="file_name" value="' . $old_name . '" /><input type="hidden" name="temp_name" value="' . $file_name . '" /><p class="submit"><input type="submit" name="submit" value="';
					printf(__("Replace (%1\$s) with (%2\$s)",'filez'), $old_name, $file_name);
					echo ' &raquo;" /></p></form>' . "\n" . '<form action ="' . get_settings('siteurl') . '/wp-content/plugins/filez/popup.php" method="post" enctype="multipart/form-data"><p class="submit"><input type="hidden" name="cancel" value="' . $file_name . '" /><input type="submit" name="submit" value="' . __('Delete','filez') . ' (' . $file_name . ') &raquo;" /></p></form>' . "\n</div>\n</body>\n</html>";
					die();
				}
			} else { // there's an error, so let's turn the error code into something human readable
				@unlink($temp_location); // delete the temp file before I forget
				echo '<div class="wrap">';
				if ($error == UPLOAD_ERR_INI_SIZE) {
					echo __('There was an error during upload. Your file may be larger than PHP allows.','filez');
				} elseif ($error == UPLOAD_ERR_FORM_SIZE) {
					printf(__('There was an error uploading <strong>%s</strong>, most likely because it is too large.','filez'),$_FILES['file_name']['name']);
				} elseif ($error == UPLOAD_ERR_PARTIAL) {
					printf(__('There was an error uploading <strong>%s</strong>. The upload may have been interrupted.','filez'),$_FILES['file_name']['name']);
				} elseif ($error == UPLOAD_ERR_NO_FILE) {
					echo __('There was an error during upload. You may have left the form empty.','filez');
				} elseif ($error == UPLOAD_ERR_NO_TMP_DIR) {
					echo __('There was an error during upload. The temp directory on your server was not found.','filez');
				} elseif ($error == UPLOAD_ERR_CANT_WRITE) {
					echo  __('There was an error during upload. The temp directory on your server is not writable.','filez');
				} else {
					echo  __('There was a mysterious error during upload.','filez');
				}
				echo "</div>\n</body>\n</html>";
				die();
			}
			if (!@move_uploaded_file($temp_location,$file_location)) {
				@unlink($temp_location);
				echo '<h3>' . __('Upload Failed','filez') . "</h3>\n<p>";
				printf(__('Your file could not be moved to <strong>%s</strong>. Make sure the folder is writable.','filez'),$filez_options['path']);
				echo "</p>\n</div>\n</body>\n</html>";
				die();
			}
			$file_link_code = '[filez:' . $file_name . ']';
			echo '<h3>' . __('File Uploaded','filez') . "</h3>\n<p>";
			printf(__("Your file <code>%s</code> was uploaded successfully!","filez"), $file_name);
			echo "</p>\n";
			if (strlen($file_name) > 25) {
				$shortfile = substr($file_name,0,22) . '...';
			} else {
				$shortfile = $file_name;
			}
			$insert_text = __('Insert','filez') . ' (' . $shortfile . ') &raquo;';
			$inserted_text = __('Inserted','filez') . ' (' . $shortfile . ') &raquo;';
			echo '<form><p class="submit"><input type="button" name="insert" value="' . $insert_text . '" onClick="insertcode(\'' . $file_name . '\'); this.form.insert.value=\'' . $inserted_text . '\'; return false;" />' . "</p></form>\n</div>\n</body>\n</html>";
		}
	}
}
?>
